## datatype99 1.6.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11.4)
project(datatype99 LANGUAGES C)

# Fix the warnings about `DOWNLOAD_EXTRACT_TIMESTAMP` in newer CMake versions.
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
    cmake_policy(SET CMP0135 NEW)
endif()

include(FetchContent)

FetchContent_Declare(
    metalang99
    URL https://github.com/Hirrolot/metalang99/archive/refs/tags/v1.13.2.tar.gz
)

FetchContent_MakeAvailable(metalang99)

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} INTERFACE metalang99)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(tests LANGUAGES C)

set(GCC_OPTIONS -Wall -Wextra -pedantic -ftrack-macro-expansion=0
                -fsanitize=address)

set(CLANG_OPTIONS -fmacro-backtrace-limit=1 -fsanitize=address)

# Enable a standard-conforming C99/C11 preprocessor.
set(MSVC_OPTIONS /std:c11)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(${GCC_OPTIONS})
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(${CLANG_OPTIONS})
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  add_compile_options(${MSVC_OPTIONS})
elseif(CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
  add_compile_definitions(ML99_ALLOW_POOR_DIAGNOSTICS)
endif()

function(set_standard TARGET NUM)
  set_target_properties(${TARGET}
                        PROPERTIES C_STANDARD ${NUM} C_STANDARD_REQUIRED ON)
endfunction()

add_executable(tests tests.c)
add_executable(metalang99_compliant metalang99_compliant.c)
add_executable(derive derive.c)
add_executable(record_derive record_derive.c)
add_executable(version version.c)

set_standard(tests 99)
set_standard(metalang99_compliant 99)
set_standard(version 99)

# For `_Static_assert`, which can be used on the same line number.
set_standard(derive 11)
set_standard(record_derive 11)

add_subdirectory(.. build)

get_property(
  TESTS
  DIRECTORY .
  PROPERTY BUILDSYSTEM_TARGETS)

foreach(TARGET ${TESTS})
  target_link_libraries(${TARGET} datatype99)
endforeach()

=== debian/changelog ===
datatype99 (1.6.4-3) unstable; urgency=medium

  * Fix Vcs-* fields in debian/control.

 -- Roland Mas <lolando@debian.org>  Tue, 30 Apr 2024 16:12:33 +0200

datatype99 (1.6.4-2) unstable; urgency=medium

  * Switch to Architecture: all. This fixes "FTBFS on mips64el: cannot
    find -lasan: No such file or directory", thanks to Andrey Rakhmatullin
    (Closes: #1069320) and "FTBFS on armel: undefined reference to
    `__atomic_store_8", thanks to Andrey Rakhmatullin (Closes: #1069319).

 -- Roland Mas <lolando@debian.org>  Tue, 30 Apr 2024 14:27:27 +0200

datatype99 (1.6.4-1) unstable; urgency=medium

  * Initial release.

 -- Roland Mas <lolando@debian.org>  Tue, 27 Feb 2024 18:12:13 +0100

=== debian/control ===
Source: datatype99
Section: devel
Priority: optional
Maintainer: Roland Mas <lolando@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libmetalang99-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/Hirrolot/datatype99
Vcs-Browser: https://salsa.debian.org/science-team/datatype99
Vcs-Git: https://salsa.debian.org/science-team/datatype99.git

Package: libdatatype99-dev
Architecture: all
Depends:
 ${misc:Depends},
 libmetalang99-dev,
Description: Algebraic data types for C99
 Safe, intuitive algebraic data types with exhaustive pattern matching
 & compile-time introspection facilities. No external tools required,
 pure C99.

## datatype99 1.6.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.11.4)
+cmake_minimum_required(VERSION 3.10.0)
 project(datatype99 LANGUAGES C)
 
 # Fix the warnings about `DOWNLOAD_EXTRACT_TIMESTAMP` in newer CMake versions.
@@ -10,7 +10,7 @@
 
 FetchContent_Declare(
     metalang99
-    URL https://github.com/Hirrolot/metalang99/archive/refs/tags/v1.13.2.tar.gz
+    URL https://github.com/hirrolot/metalang99/archive/refs/tags/v1.13.5.tar.gz
 )
 
 FetchContent_MakeAvailable(metalang99)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(examples LANGUAGES C)

set(GCC_OPTIONS -Wall -Wextra -pedantic -ftrack-macro-expansion=0
                -fsanitize=address)

set(CLANG_OPTIONS -fmacro-backtrace-limit=1 -fsanitize=address)

# Enable a standard-conforming C99/C11 preprocessor.
set(MSVC_OPTIONS /std:c11)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(${GCC_OPTIONS})
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(${CLANG_OPTIONS})
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  add_compile_options(${MSVC_OPTIONS})
elseif(CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
  add_compile_definitions(ML99_ALLOW_POOR_DIAGNOSTICS)
endif()

add_executable(array_in_variant array_in_variant.c)
add_executable(ast ast.c)
add_executable(binary_tree_malloc binary_tree_malloc.c)
add_executable(binary_tree binary_tree.c)
add_executable(token token.c)

add_subdirectory(derive)

add_subdirectory(.. build)

get_property(
  EXAMPLES
  DIRECTORY .
  PROPERTY BUILDSYSTEM_TARGETS)

get_property(
  DERIVE_EXAMPLES
  DIRECTORY derive
  PROPERTY BUILDSYSTEM_TARGETS)

foreach(TARGET ${EXAMPLES};${DERIVE_EXAMPLES})
  target_link_libraries(${TARGET} datatype99)
  set_target_properties(${TARGET} PROPERTIES C_STANDARD 99 C_STANDARD_REQUIRED
                                                           ON)
endforeach()

=== examples/derive/CMakeLists.txt ===
add_executable(metadata metadata.c)
add_executable(record_metadata record_metadata.c)
add_executable(print print.c)
add_executable(command_menu command_menu.c)

=== debian/changelog ===
datatype99 (1.6.5-1) unstable; urgency=medium

  * Import upstream version 1.6.5.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 04 Oct 2025 22:17:57 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: datatype99
+Standards-Version: 4.7.2
+Maintainer: Roland Mas <lolando@debian.org>
 Section: devel
-Priority: optional
-Maintainer: Roland Mas <lolando@debian.org>
-Rules-Requires-Root: no
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- cmake,
  libmetalang99-dev,
-Standards-Version: 4.6.2
-Homepage: https://github.com/Hirrolot/datatype99
 Vcs-Browser: https://salsa.debian.org/science-team/datatype99
 Vcs-Git: https://salsa.debian.org/science-team/datatype99.git
+Homepage: https://github.com/Hirrolot/datatype99
 
 Package: libdatatype99-dev
 Architecture: all

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/Hirrolot/datatype99/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
